/*
 * SPDX-FileCopyrightText: 2022 Digital Dasein <https://digital-dasein.gitlab.io/>
 * SPDX-FileCopyrightText: 2022 Gerben Peeters <gerben@digitaldasein.org>
 * SPDX-FileCopyrightText: 2022 Senne Van Baelen <senne@digitaldasein.org>
 *
 * SPDX-License-Identifier: MIT
 */

/* ###############################
 * # SHOWER CSS
 * ##############################
 *
 * Containing:
 * ==========
 * - DD-COMPLIANCE
 * - SHOWER MAIN
 * - PROGRESS
 * - SLIDE
 * - REGION
 *
 */

/* ============= */
/* DD COMPLIANCE */
/* ============= */

dd-slide-collection {
    margin:0;
    /*max-height:0;*/
}

dd-slide,
dd-titlepage,
.slide {
    overflow:hidden;
}

/* ============= */
/* SHOWER MAIN   */
/* ============= */

.shower {
    --slide-gap: var(--dd-slide-gap, 96px);
    --slide-ratio: var(--dd-slide-ratio, calc(16 / 9));
    --slide-width: var(--dd-slide-width, 1024px);
    --slide-height: calc(
        var(--slide-width) / var(--slide-ratio)
    );

    --progress-size: 5px;
    --progress-color: var(--dd-prim-color, rgba(153, 155, 132, 1));

    -webkit-text-size-adjust: none;
    -moz-text-size-adjust: none;
    -ms-text-size-adjust: none;

    margin: 0;
    color: black;
    counter-reset: slide;
    font: var(--dd-font);
}

/* Shower Full */

.shower.full {
    position: absolute;
    top: 50%;
    left: 50%;
    overflow: hidden;
    margin-top: calc(var(--slide-height) / 2 * -1);
    margin-left: calc(var(--slide-width) / 2 * -1);
    width: var(--slide-width);
    height: var(--slide-height);
    background-color: black;
    transform: scale(var(--shower-full-scale));
}

/* Print */

@media print {
    @page { margin: 0; size: 1024px 576px; }
    .shower {
        -webkit-print-color-adjust: exact;
        text-rendering: geometricPrecision;
    }
}

/* ========== */
/* PROGRESS   */
/* ========== */

.progress {
    position: absolute;
    bottom: 0;
    left: 0;
    width: 0;
    height: var(--progress-size);
    background-color: var(--progress-color);
    transition: width 0.2s linear;
    box-shadow:
        calc(var(--slide-width) / 2) 0 0
        calc(var(--slide-width) / 2)
        var(--color-light);
    clip: rect(0 var(--slide-width) var(--progress-size) 0);
}

/* List */

.shower.list .progress {
    display: none;
}

/* Full */

.shower.full .progress {
    display: block;
}

/* Print */

@media print {
    .shower.list .progress,
    .shower.full .progress {
        display: none;
    }
}

/* ========== */
/* SLIDE      */
/* ========== */

.shower.full .slide {
    position: absolute;
    top: 0;
    left: 0;
    clip: rect(0 0 0 0);
    visibility: hidden;
}

/* Active */

.shower.full .slide.active {
    clip: auto;
    visibility: visible;
}

/* Code */

.slide pre {
    margin-top: 0;
    margin-bottom: 1em;
    counter-reset: code;
    white-space: normal;
}

/* Inner */

.slide pre code {
    display: block;
    margin-left: calc(
        var(--slide-left-side) * -1
    );
    padding: 0 0 0 var(--slide-left-side);
    width: calc(
        100% +
        var(--slide-left-side) +
        var(--slide-right-side)
    );
    background-color: transparent;
    line-height: 2;
    white-space: pre;
    -moz-tab-size: 4;
    tab-size: 4;
}

/* Line Numbers */

.slide pre code:not(:only-child)::before {
    position: absolute;
    margin-left: -2em;
    color: var(--color-light);
    counter-increment: code;
    content: counter(code, decimal-leading-zero) '.';
}

/* Marked */

.slide pre mark {
    position: relative;
    z-index: -1;
    margin: 0 -0.3em;
}

/* Important */

.slide pre mark.important {
    background-color: var(--color-key);
    color: white;
}

/* Comment */

.slide pre .comment {
    color: var(--color-medium);
}

/* Marked Line */

.slide pre code:not(:only-child).mark {
    background-color: var(--color-yellow);
}

/* Next Line */

.slide pre code:not(:only-child).mark.next {
    visibility: visible;
    background-color: transparent;
}

.slide pre code:not(:only-child).mark.next.active,
.slide pre code:not(:only-child).mark.next.visited {
    background-color: var(--color-yellow);
}

/* Full */

.shower.full .slide pre code:not(:only-child).mark.next {
    visibility: visible;
    background-color: transparent;
}

.shower.full .slide pre code:not(:only-child).mark.next.active,
.shower.full .slide pre code:not(:only-child).mark.next.visited {
    background-color: var(--color-yellow);
}

/* Next */

.shower.full .next {
    visibility: hidden;
}

.shower.full .next.active,
.shower.full .next.visited {
    visibility: visible;
}

/* ========== */
/* REGION     */
/* ========== */

/* Note: required for shower JS interactions */

.region {
    position: absolute;
    top: 0;
    left: 0;
    clip: rect(0 0 0 0);
}

/* List */

.shower.list .region {
    display: none;
}

/* Full */

.shower.full .region {
    display: block;
}

/* Print */

@media print {
    .shower.list .region,
    .shower.full .region {
        display: none;
    }
}
